Your search did not match any results.

Progress Bar

Documentation

This demo shows how to configure the ProgressBar component.

To create a ProgressBar, declare it in markup. You can specify the following properties to change the ProgressBar's numeric scale:

  • min and max
    The min and max properties limit the range of accepted values.

  • value
    This property specifies the current value. If you want to switch the ProgressBar to an indeterminate state, set the value property to false.

This demo uses the custom timer function to increase the ProgressBar's value.

When the ProgressBar reaches the maximum value, the complete event occurs. Use the onComplete function to handle it.

The progress status displays a ratio between the current and maximum values and indicates the progress. Use the showStatus property to display or hide the status string. To format the status string, use the statusFormat function.

Backend API
$(() => { let seconds = 10; let inProgress = false; let intervalId; const progressBarStatus = $('#progressBarStatus').dxProgressBar({ min: 0, max: 100, width: '90%', statusFormat(ratio) { return `Loading: ${ratio * 100}%`; }, onComplete(e) { inProgress = false; progressButton.option('text', 'Restart progress'); e.element.addClass('complete'); }, }).dxProgressBar('instance'); const progressButton = $('#progress-button').dxButton({ text: 'Start progress', width: 200, onClick() { $('#progressBarStatus').removeClass('complete'); if (inProgress) { progressButton.option('text', 'Continue progress'); clearInterval(intervalId); } else { progressButton.option('text', 'Stop progress'); setCurrentStatus(); intervalId = setInterval(timer, 1000); } inProgress = !inProgress; }, }).dxButton('instance'); function setCurrentStatus() { progressBarStatus.option('value', (10 - seconds) * 10); $('#timer').text((`0${seconds}`).slice(-2)); } function timer() { seconds -= 1; setCurrentStatus(); if (seconds === 0) { clearInterval(intervalId); seconds = 10; } } });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.6/css/dx.light.css" /> <script src="https://cdn3.devexpress.com/jslib/23.1.6/js/dx.all.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div class="form"> <div id="progress-button"></div> <div class="progress-info"> Time left 00:00:<span id="timer">10</span> </div> <div id="progress"><div id="progressBarStatus"></div></div> </div> </div> </body> </html>
.form { padding: 20% 0; text-align: center; } #progress-button { margin-bottom: 20px; } #progressBarStatus { display: inline-block; } .complete .dx-progressbar-range { background-color: green; }

import React from 'react';
import { Button } from 'devextreme-react/button';
import { ProgressBar } from 'devextreme-react/progress-bar';
const maxValue = 10;
function formatTime(value) {
return `00:00:${(`0${value}`).slice(-2)}`;
}
function statusFormat(ratio) {
return `Loading: ${ratio * 100}%`;
}
let intervalId;
class App extends React.Component {
constructor(props) {
super(props);
this.state = {
seconds: maxValue,
buttonText: 'Start progress',
inProgress: false,
};
this.onButtonClick = this.onButtonClick.bind(this);
this.timer = this.timer.bind(this);
}
render() {
return (
<div className="form">
<Button
id="progress-button"
text={this.state.buttonText}
width={200}
onClick={this.onButtonClick}
/>
<div className="progress-info">
Time left {formatTime(this.state.seconds)}
</div>
<ProgressBar
id="progress-bar-status"
className={this.state.seconds === 0 ? 'complete' : '' }
width="90%"
min={0}
max={maxValue}
statusFormat={statusFormat}
value={maxValue - this.state.seconds}
/>
</div>
);
}
onButtonClick() {
const state = {
inProgress: !this.state.inProgress,
};
if (this.state.inProgress) {
state.buttonText = 'Continue progress';
clearInterval(intervalId);
} else {
state.buttonText = 'Stop progress';
if (this.state.seconds === 0) {
state.seconds = maxValue;
}
intervalId = setInterval(() => this.timer(), 1000);
}
this.setState(state);
}
timer() {
const state = {
seconds: this.state.seconds - 1,
};
if (state.seconds === 0) {
state.buttonText = 'Restart progress';
state.inProgress = !this.state.inProgress;
clearInterval(intervalId);
}
this.setState(state);
}
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.5/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.form {
padding: 20% 0;
text-align: center;
}
#progress-button {
margin-bottom: 20px;
}
#progress-bar-status {
display: inline-block;
}
.complete .dx-progressbar-range {
background-color: green;
}
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@23.1.6/cjs',
'devextreme-react': 'npm:devextreme-react@23.1.6',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.6.2/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.2/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.49/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);

<template>
<div class="form">
<DxButton
id="progress-button"
:text="buttonText"
:width="200"
:on-click="onButtonClick"
/>
<div class="progress-info">
Time left {{ time(seconds) }}
</div>
<DxProgressBar
id="progress-bar-status"
:class="{complete: seconds == 0}"
:min="0"
:max="maxValue"
:status-format="statusFormat"
:value="progressValue"
width="90%"
/>
</div>
</template>
<script>
import { DxButton } from 'devextreme-vue/button';
import { DxProgressBar } from 'devextreme-vue/progress-bar';
const maxValue = 10;
function statusFormat(ratio) {
return `Loading: ${ratio * 100}%`;
}
export default {
components: {
DxButton,
DxProgressBar,
},
data() {
return {
maxValue,
seconds: maxValue,
buttonText: 'Start progress',
inProgress: false,
statusFormat,
};
},
computed: {
progressValue() {
return maxValue - this.seconds;
},
},
methods: {
time(value) {
return `00:00:${(`0${value}`).slice(-2)}`;
},
onButtonClick() {
if (this.inProgress) {
this.buttonText = 'Continue progress';
clearInterval(this.intervalId);
} else {
this.buttonText = 'Stop progress';
if (this.seconds === 0) {
this.seconds = maxValue;
}
this.intervalId = setInterval(() => this.timer(), 1000);
}
this.inProgress = !this.inProgress;
},
timer() {
this.seconds -= 1;
if (this.seconds === 0) {
this.buttonText = 'Restart progress';
this.inProgress = !this.inProgress;
clearInterval(this.intervalId);
}
},
},
};
</script>
<style>
.form {
padding: 20% 0;
text-align: center;
}
#progress-button {
margin-bottom: 20px;
}
#progress-bar-status {
display: inline-block;
}
.complete .dx-progressbar-range {
background-color: green;
}
</style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.5/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'root:': '../../../../../',
'npm:': 'https://unpkg.com/',
},
map: {
'vue': 'npm:vue@3.3.4/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.1/index.js',
'demo-ts-loader': 'root:utils/demo-ts-loader.js',
'svg-loader': 'root:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@23.1.6/cjs',
'devextreme-vue': 'npm:devextreme-vue@23.1.6',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.6.2/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.2/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.49/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);

<div class="form">
<dx-button
id="progress-button"
[(text)]="buttonText"
(onClick)="onButtonClick()"
[width]="200"
>
</dx-button>
<div class="progress-info"> Time left {{ seconds | time }} </div>
<dx-progress-bar
#progressBar
id="progress-bar-status"
width="90%"
[class.complete]="progressBar.value == maxValue"
[min]="0"
[max]="maxValue"
[statusFormat]="format"
[value]="maxValue - seconds"
>
</dx-progress-bar>
</div>
import {
NgModule, Component, Pipe, PipeTransform, enableProdMode,
} from '@angular/core';
import { BrowserModule, BrowserTransferStateModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxButtonModule, DxProgressBarModule } from 'devextreme-angular';
@Pipe({ name: 'time' })
export class TimePipe implements PipeTransform {
transform(value: number): string {
return `00:00:${(`0${value}`).slice(-2)}`;
}
}
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
})
export class AppComponent {
buttonText = 'Start progress';
inProgress = false;
seconds = 10;
maxValue = 10;
intervalId: number;
onButtonClick() {
if (this.inProgress) {
this.buttonText = 'Continue progress';
clearInterval(this.intervalId);
} else {
this.buttonText = 'Stop progress';
if (this.seconds === 0) {
this.seconds = 10;
}
this.intervalId = window.setInterval(() => this.timer(), 1000);
}
this.inProgress = !this.inProgress;
}
timer() {
this.seconds--;
if (this.seconds == 0) {
this.buttonText = 'Restart progress';
this.inProgress = !this.inProgress;
clearInterval(this.intervalId);
}
}
format(ratio) {
return `Loading: ${ratio * 100}%`;
}
}
@NgModule({
imports: [
BrowserModule,
BrowserTransferStateModule,
DxButtonModule,
DxProgressBarModule,
],
declarations: [AppComponent, TimePipe],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep .form {
padding: 20% 0;
text-align: center;
}
::ng-deep #progress-button {
margin-bottom: 20px;
}
::ng-deep #progress-bar-status {
display: inline-block;
}
::ng-deep .complete .dx-progressbar-range {
background-color: green;
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'@angular/core': 'npm:@angular/core@12.2.17',
'@angular/platform-browser': 'npm:@angular/platform-browser@12.2.17',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.17',
'@angular/forms': 'npm:@angular/forms@12.2.17',
'@angular/common': 'npm:@angular/common@12.2.17',
'@angular/compiler': 'npm:@angular/compiler@12.2.17',
'tslib': 'npm:tslib@2.3.1/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@23.1.6/cjs',
'devextreme/bundles/dx.all': 'npm:devextreme@23.1.6/bundles/dx.all.js',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.6.2/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.2',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.49',
'devextreme-angular': 'npm:devextreme-angular@23.1.6',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
'npm:@angular/*/package.json',
'npm:@angular/common@12.2.17/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devextreme-angular@23.1.6/*/package.json',
'npm:devextreme-angular@23.1.6/ui/*/package.json',
'npm:devextreme-angular@23.1.6/package.json',
'npm:devexpress-diagram@2.2.2/package.json',
'npm:devexpress-gantt@4.1.49/package.json',
],
};
System.config(window.config);
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.5/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.12.0/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>